.TH ordsets 3 "stdlib  1.16.3" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
ordsets \- Functions for Manipulating Sets as Ordered Lists
.SH DESCRIPTION
.LP
Sets are collections of elements with no duplicate elements\&. An \fIordset\fR is a representation of a set, where an ordered list is used to store the elements of the set\&. An ordered list is more efficient than an unordered list\&.
.LP
This module provides exactly the same interface as the module \fIsets\fR but with a defined representation\&. One difference is that while \fIsets\fR considers two elements as different if they do not match (\fI=:=\fR), this module considers two elements as different if and only if they do not compare equal (\fI==\fR)\&.

.SH DATA TYPES

.nf
ordered_set()
  as returned by new/0
.fi
.SH EXPORTS
.LP
.B
new() -> Ordset
.br
.RS
.TP
Types
Ordset = ordered_set()
.br
.RE
.RS
.LP
Returns a new empty ordered set\&.
.RE
.LP
.B
is_set(Ordset) -> bool()
.br
.RS
.TP
Types
Ordset = term()
.br
.RE
.RS
.LP
Returns \fItrue\fR if \fIOrdset\fR is an ordered set of elements, otherwise \fIfalse\fR\&.
.RE
.LP
.B
size(Ordset) -> int()
.br
.RS
.TP
Types
Ordset = term()
.br
.RE
.RS
.LP
Returns the number of elements in \fIOrdset\fR\&.
.RE
.LP
.B
to_list(Ordset) -> List
.br
.RS
.TP
Types
Ordset = ordered_set()
.br
List = [term()]
.br
.RE
.RS
.LP
Returns the elements of \fIOrdset\fR as a list\&.
.RE
.LP
.B
from_list(List) -> Ordset
.br
.RS
.TP
Types
List = [term()]
.br
Ordset = ordered_set()
.br
.RE
.RS
.LP
Returns an ordered set of the elements in \fIList\fR\&.
.RE
.LP
.B
is_element(Element, Ordset) -> bool()
.br
.RS
.TP
Types
Element = term()
.br
Ordset = ordered_set()
.br
.RE
.RS
.LP
Returns \fItrue\fR if \fIElement\fR is an element of \fIOrdset\fR, otherwise \fIfalse\fR\&.
.RE
.LP
.B
add_element(Element, Ordset1) -> Ordset2
.br
.RS
.TP
Types
Element = term()
.br
Ordset1 = Ordset2 = ordered_set()
.br
.RE
.RS
.LP
Returns a new ordered set formed from \fIOrdset1\fR with \fIElement\fR inserted\&.
.RE
.LP
.B
del_element(Element, Ordset1) -> Ordset2
.br
.RS
.TP
Types
Element = term()
.br
Ordset1 = Ordset2 = ordered_set()
.br
.RE
.RS
.LP
Returns \fIOrdset1\fR, but with \fIElement\fR removed\&.
.RE
.LP
.B
union(Ordset1, Ordset2) -> Ordset3
.br
.RS
.TP
Types
Ordset1 = Ordset2 = Ordset3 = ordered_set()
.br
.RE
.RS
.LP
Returns the merged (union) set of \fIOrdset1\fR and \fIOrdset2\fR\&.
.RE
.LP
.B
union(OrdsetList) -> Ordset
.br
.RS
.TP
Types
OrdsetList = [ordered_set()]
.br
Ordset = ordered_set()
.br
.RE
.RS
.LP
Returns the merged (union) set of the list of sets\&.
.RE
.LP
.B
intersection(Ordset1, Ordset2) -> Ordset3
.br
.RS
.TP
Types
Ordset1 = Ordset2 = Ordset3 = ordered_set()
.br
.RE
.RS
.LP
Returns the intersection of \fIOrdset1\fR and \fIOrdset2\fR\&.
.RE
.LP
.B
intersection(OrdsetList) -> Ordset
.br
.RS
.TP
Types
OrdsetList = [ordered_set()]
.br
Ordset = ordered_set()
.br
.RE
.RS
.LP
Returns the intersection of the non-empty list of sets\&.
.RE
.LP
.B
is_disjoint(Ordset1, Ordset2) -> bool()
.br
.RS
.TP
Types
Ordset1 = Ordset2 = ordered_set()
.br
.RE
.RS
.LP
Returns \fItrue\fR if \fIOrdset1\fR and \fIOrdset2\fR are disjoint (have no elements in common), and \fIfalse\fR otherwise\&.
.RE
.LP
.B
subtract(Ordset1, Ordset2) -> Ordset3
.br
.RS
.TP
Types
Ordset1 = Ordset2 = Ordset3 = ordered_set()
.br
.RE
.RS
.LP
Returns only the elements of \fIOrdset1\fR which are not also elements of \fIOrdset2\fR\&.
.RE
.LP
.B
is_subset(Ordset1, Ordset2) -> bool()
.br
.RS
.TP
Types
Ordset1 = Ordset2 = ordered_set()
.br
.RE
.RS
.LP
Returns \fItrue\fR when every element of \fIOrdset\fR1 is also a member of \fIOrdset2\fR, otherwise \fIfalse\fR\&.
.RE
.LP
.B
fold(Function, Acc0, Ordset) -> Acc1
.br
.RS
.TP
Types
Function = fun (E, AccIn) -> AccOut
.br
Acc0 = Acc1 = AccIn = AccOut = term()
.br
Ordset = ordered_set()
.br
.RE
.RS
.LP
Fold \fIFunction\fR over every element in \fIOrdset\fR returning the final value of the accumulator\&.
.RE
.LP
.B
filter(Pred, Ordset1) -> Set2
.br
.RS
.TP
Types
Pred = fun (E) -> bool()
.br
Set1 = Set2 = ordered_set()
.br
.RE
.RS
.LP
Filter elements in \fISet1\fR with boolean function \fIFun\fR\&.
.RE
.SH SEE ALSO
.LP
gb_sets(3), sets(3)
